package com.pixelized.server.lwa.server.rest.map

import com.pixelized.server.lwa.server.Engine
import com.pixelized.server.lwa.utils.extentions.exception
import com.pixelized.server.lwa.utils.extentions.mapId
import com.pixelized.shared.lwa.protocol.rest.APIResponse
import com.pixelized.shared.lwa.protocol.websocket.ApiSynchronisation
import io.ktor.server.response.respond
import io.ktor.server.routing.RoutingContext

fun Engine.deleteMap(): suspend RoutingContext.() -> Unit {
    return {
        try {
            // get the query parameter
            val mapId = call.queryParameters.mapId
            // delete the map.
            mapService.delete(
                mapId = mapId,
            )
            // API & WebSocket responses.
            call.respond(
                message = APIResponse.success(),
            )
            webSocket.emit(
                value = ApiSynchronisation.MapDelete(
                    timestamp = System.currentTimeMillis(),
                    id = mapId,
                ),
            )
        } catch (exception: Exception) {
            call.exception(
                exception = exception,
            )
        }
    }
}